import{reduceParents}from"./reduce.js";
import{setValue}from"./set.js";
import{validateClasses}from"./validate.js";


export const remove=(
target,
query,
{mutate=false,leaves=false,shallowArrays,classes,inherited}={})=>
{
validateClasses(classes,mutate);
const setFunc=removeAnyEntry.bind(undefined,mutate);
return reduceParents({
target,
query,
setFunc,
missing:false,
leaves,
shallowArrays,
classes,
inherited
})
};


const removeAnyEntry=(mutate,target,path,index)=>
path.length===0?undefined:removeEntry({mutate,target,path,index});

const removeEntry=({mutate,target,path,index})=>{
const prop=path[index];

if(index===path.length-1){
return removeValue(target,prop,mutate)
}

const childTarget=target[prop];
const childValue=removeEntry({
mutate,
target:childTarget,
path,
index:index+1
});
return setValue({target,prop,childValue,mutate})
};

const removeValue=(target,prop,mutate)=>
Array.isArray(target,prop)?
removeArrayValue(target,prop,mutate):
removeObjectValue(target,prop,mutate);

const removeArrayValue=(target,index,mutate)=>{
if(target[index]===undefined){
return target
}

const targetA=mutate?target:[...target];

targetA[index]=undefined;
return trimUndefined(targetA,mutate)
};

const trimUndefined=(target,mutate)=>{
if(target.some(isDefined)){
return target
}

if(mutate){

target.splice(0);
return target
}

return[]
};

const isDefined=(item)=>item!==undefined;

const removeObjectValue=(target,prop,mutate)=>{
const targetA=mutate?target:{...target};

delete targetA[prop];
removeInheritedValue(targetA,prop,mutate);
return targetA
};






const removeInheritedValue=(target,prop,mutate)=>{
if(mutate&&prop in target){

target[prop]=undefined
}
};